﻿/*
	Author:		Dmitry Kochergin aka sp!rt
	Version:	1.10
	Date:		16.05.2010
*/
var delivery_cost = 9.95;
var card_operation_cost = 5;
var fees = delivery_cost + card_operation_cost;

var myUsers = {
	"users": [],
	"add_user_obj": null,
	"cookie_users_name": "myUsers",

	"CreateUserTotal": function(x)
	{
		for(var i = 0, total_table_text, objDelUser; i < myUsers.UserCount(); i++)
		{
			x.appendChild(this.CreateDelUser(i));
			x.appendChild(document.createTextNode(" "));
			x.appendChild(total_table_text = document.createElement("strong"));
			total_table_text.text = this.users[i];
			x.appendChild(document.createElement("br"));
		}
	},

	"GetAddUser": function()
	{
		var obj = this.add_user_obj;
		if (obj == null)
		{
			obj = document.createElement("strong");
			obj.text = "+";
			obj.onclick = AddUser;
			obj.style.color = "#ea640d";
		}
		return obj;
	},
	
	"CreateDelUser": function(x)
	{
		var obj;
		obj = document.createElement("strong");
		obj.text = "-";
		obj.onclick = "DeleteUser(" + x + ")";
		obj.style.color = "#ea640d";
		return obj;
	},

	"Add": function(username)
	{
		if (!username)
		{
			var prompt_str = "<Имя>";
			username = prompt("Укажите имя добавляемого участника", prompt_str);
			if (username == null || username == prompt_str) return false;
		}
		this.users.push(username);
		this.Save();
		return true;
	},
	
	"Del": function(x)
	{
		this.users.splice(x, 1);
		this.Save();
	},
	
	"UserCount": function()
	{
		return this.users.length;
	},

	"Save": function()
	{
		SetCookie(this.cookie_users_name, this.users.toString());
	},
	
	"Load": function()
	{
		var users_str = GetCookie(this.cookie_users_name);
		if (users_str == "") return;
		this.users = users_str.split("%2C");
	}
}

var myCurrency = {
	"value": 0.0,
	"objEdit": null,
	"objView": null,
	"objSize": 40,
	"cookie_currency_name": "myCurrency",
	
	"Create": function()
	{
		var obj;
		var fragment = document.createDocumentFragment();

		fragment.appendChild(obj = document.createElement("span"));
		obj.style.color = "grey";
		obj.onclick = "myCurrency.ChangeStart()";
		this.objView = obj;

		fragment.appendChild(obj = document.createElement("input"));
		obj.type = "text";
		obj.style.textAlign = "right";
		obj.style.width = this.objEditSize;
		obj.style.border = 0;
		obj.onblur = "myCurrency.ChangeStop()";
		this.objEdit = obj;

		fragment.appendChild(document.createTextNode(" "));
		fragment.appendChild(obj = document.createElement("span"));
		obj.text = "RUR";
		obj.style.color = "grey";

		this.Load();
		this.ShowEdit(false);
		this.ShowView(true);

		return fragment;
	},
	
	"Refresh": function()
	{
		this.objEdit.value = OutputCost(this.value);
		this.objView.text = OutputCost(this.value);
	},

	"ShowView": function(x)
	{
		if (x)
		{
			this.objView.style.visibility = "visible";
			this.objView.style.width = this.objSize;
		}
		else
		{
			this.objView.style.visibility = "hidden";
			this.objView.style.width = 0;
		}
	},
	
	"ShowEdit": function(x)
	{
		if (x)
		{
			this.objEdit.style.visibility = "visible";
			this.objEdit.style.width = this.objSize;
			this.objEdit.focus();
		}
		else
		{
			this.objEdit.style.visibility = "hidden";
			this.objEdit.style.width = 0;
		}
	},
	
	"ChangeStart": function()
	{
		this.ShowEdit(true);
		this.ShowView(false);
	},

	"ChangeStop": function()
	{
		this.ShowEdit(false);
		this.ShowView(true);
		this.value = CostToFloat(this.objEdit.value);
		this.Save();
		this.Refresh();
		myTotal.Recalc();
	},
	
	"Save": function()
	{
		SetCookie(this.cookie_currency_name, this.value);
	},

	"Load" : function()
	{
		var users_str = GetCookie(this.cookie_currency_name);
		if (users_str == "")
		{
			this.value = 0.0;
		}
		else
		{
			this.value = CostToFloat(users_str);
		}
		this.Refresh();
	}
}

var myLines = {
	"length": 0,
	"user_bars": [],
	"quantities": [],
	"pay_prices": [],
	"pay_costs": [],
	"other_prices": [],
	"active_flags": [],
	"cookie_choice_name": "myChoice",

	"Create": function(price, quantity_text)
	{
		this.quantities.push(quantity_text);
		quantity_text.onchange = "myTotal.Recalc()";

		var goods_table_myline = document.createElement("tr");
		var goods_table_mycell, goods_table_other_price;

		goods_table_myline.appendChild(goods_table_mycell = document.createElement("td"));
		goods_table_mycell.colSpan = 2;
		goods_table_mycell.appendChild(this.CreateAFlag());
		goods_table_mycell.appendChild(document.createTextNode(" "));
		goods_table_mycell.appendChild(this.CreateUBar(price));

		goods_table_myline.appendChild(goods_table_mycell = document.createElement("td"));
		goods_table_mycell.colSpan = 2;
		goods_table_mycell.style.textAlign = "right";
		goods_table_mycell.appendChild(this.CreateOPrice());

		this.length++;
		return goods_table_myline;
	},

	"CreateUBar": function(price)
	{
		var obj = document.createElement("select");
		obj.style.width = "80%";
		obj.onchange = onChangeUBar;
		obj.name = price;
		this.user_bars.push(obj);
		return obj;
	},

	"RefreshUBars": function()
	{
		var obj, user_choose_option;
		for(var j = 0; j < this.user_bars.length; j++)
		{
			obj = this.user_bars[j];
			// очистить
			ClearNode(obj);
			// наполнение
			for(var i = 0; i < myUsers.UserCount(); i++)
			{
				user_choose_option = document.createElement("option");
				obj.appendChild(user_choose_option);
				user_choose_option.text = myUsers.users[i];
				user_choose_option.value = i;
			}
		}
		this.LoadChoice();
		this.SaveChoice();//от "мусора"
	},

	"CreateAFlag": function()
	{
		var obj = document.createElement("input");
		obj.type = "checkbox";
		obj.onchange = "myTotal.Recalc()";
		obj.checked = "1";
		this.active_flags.push(obj);
		return obj;
	},

	"CreatePPrice": function()
	{
		var obj;
		var fragment = document.createDocumentFragment();
		fragment.appendChild(obj = document.createElement("span"));
		obj.style.color = "grey";
		obj.text = "0,00";
		this.pay_prices.push(obj);
		fragment.appendChild(document.createTextNode(" "));
		fragment.appendChild(obj = document.createElement("span"));
		obj.style.color = "grey";
		obj.text = "EUR";
		return fragment;
	},

	"CreatePCost": function()
	{
		var obj;
		var fragment = document.createDocumentFragment();
		fragment.appendChild(obj = document.createElement("strong"));
		obj.style.color = "grey";
		obj.text = "0,00";
		this.pay_costs.push(obj);
		fragment.appendChild(document.createTextNode(" "));
		fragment.appendChild(obj = document.createElement("strong"));
		obj.style.color = "grey";
		obj.text = "EUR";		
		return fragment;
	},
	
	"CreateOPrice": function()
	{
		var obj;
		var fragment = document.createDocumentFragment();
		fragment.appendChild(obj = document.createElement("input"));
		this.other_prices.push(obj);
		obj.type = "text";
		obj.onchange = "myTotal.Recalc()";
		obj.size = 6;
		obj.style.textAlign = "right";
		obj.value = "0,00";
		fragment.appendChild(document.createTextNode(" "));
		fragment.appendChild(document.createTextNode("EUR"));
		return fragment;
	},
	
	"GetPrice": function(x)
	{
		return CostToFloat(this.user_bars[x].name);
	},

	"GetOtherPrice": function(x)
	{
		return CostToFloat(this.other_prices[x].value);
	},	

	"GetUserIndex": function(x)
	{
		return this.user_bars[x].value;
	},
	
	"GetQuantitiy": function(x)
	{
		return this.quantities[x].value;
	},

	"GetChecked": function(x)
	{
		return this.active_flags[x].checked;
	},

	"SaveChoice": function()
	{
		var choice_arr = Array(this.user_bars.length);
		for(var i = 0, str = ''; i < this.user_bars.length; i++)
		{
			choice_arr[i] = this.GetUserIndex(i);
		}
		SetCookie(this.cookie_choice_name, choice_arr.toString());
	},
	
	"LoadChoice": function()
	{
		var choice_str = GetCookie(this.cookie_choice_name);
		if (choice_str == "") return;
		var choice_arr = choice_str.split("%2C");
		for(var i = 0, str = ''; i < this.user_bars.length; i++)
		{
			this.user_bars[i].value = choice_arr[i];
		}
	}
}

var myTotal = {
	"node_line": null,
	"name_cell": null,
	"eur_cell": null,
	"rur_cell": null,
	"user_structs_cost_eur": [],
	"user_structs_cost_rur": [],
	"total_eur_text": null,
	"total_rur_text": null,

	"Create": function()
	{
		if (this.node_line != null) return null;

		this.node_line = document.createElement("tr");
		this.node_line.className = "total";

		this.node_line.appendChild(this.name_cell = document.createElement("td"));

		this.node_line.appendChild(this.eur_cell = document.createElement("td"));
		this.eur_cell.colSpan = 2;
		this.eur_cell.style.textAlign = "right";

		this.node_line.appendChild(this.rur_cell = document.createElement("td"));
		this.rur_cell.colSpan = 2;
		this.rur_cell.style.textAlign = "right";

		return this.node_line;
	},

	"Clear": function()
	{
		ClearNode(this.name_cell);
		ClearNode(this.eur_cell);
		ClearArray(this.user_structs_cost_eur);
		ClearNode(this.rur_cell);
		ClearArray(this.user_structs_cost_rur);
	},
	
	"Refresh": function()
	{
		var total_table_text;
		// очистка
		this.Clear();
		// наполнение ...
		// name_cell
		myUsers.CreateUserTotal(this.name_cell);//добавить имена всех участников
		this.name_cell.appendChild(myUsers.GetAddUser());
		this.name_cell.appendChild(document.createElement("br"));
		this.name_cell.appendChild(document.createElement("br"));
		this.name_cell.appendChild(document.createElement("hr"));
		this.name_cell.appendChild(total_table_text = document.createElement("strong"));
		total_table_text.text = "#Total (+VAT)";
		// eur_cell
		for(var i = 0; i < myUsers.UserCount(); i++)
		{
			this.eur_cell.appendChild(total_table_text = document.createElement("span"));
			this.user_structs_cost_eur.push(total_table_text);
			this.eur_cell.appendChild(document.createTextNode(" "));
			this.eur_cell.appendChild(document.createTextNode("EUR"));
			this.eur_cell.appendChild(document.createElement("br"));
		}
		this.eur_cell.appendChild(total_table_text = document.createElement("span"));
		total_table_text.text = "EUR =";
		total_table_text.style.color = "grey";
		total_table_text.onclick = "myCurrency.ChangeStart()";
		this.eur_cell.appendChild(document.createElement("br"));
		this.eur_cell.appendChild(document.createElement("br"));
		this.eur_cell.appendChild(document.createElement("hr"));
		this.eur_cell.appendChild(this.total_eur_text = document.createElement("span"));
		this.eur_cell.appendChild(document.createTextNode(" "));
		this.eur_cell.appendChild(document.createTextNode("EUR"));
		// rur_cell
		for(var i = 0; i < myUsers.UserCount(); i++)
		{
			this.rur_cell.appendChild(total_table_text = document.createElement("span"));
			this.user_structs_cost_rur.push(total_table_text);
			this.rur_cell.appendChild(document.createTextNode(" "));
			this.rur_cell.appendChild(document.createTextNode("RUR"));
			this.rur_cell.appendChild(document.createElement("br"));
		}
		this.rur_cell.appendChild(myCurrency.Create());
		this.rur_cell.appendChild(document.createElement("br"));
		this.rur_cell.appendChild(document.createElement("br"));
		this.rur_cell.appendChild(document.createElement("hr"));
		this.rur_cell.appendChild(this.total_rur_text = document.createElement("span"));
		this.rur_cell.appendChild(document.createTextNode(" RUR"));
		// пересчёт
		this.Recalc();
	},
	
	"Recalc": function()
	{
		// инициализация
		var cost_total_with_vat = 0;
		var user_pays_total_without_vat = 0;
		var fees_tmp = fees;
		var user_pays = Array(myUsers.UserCount());
		for(var i = 0; i < user_pays.length; i++)
		{
			user_pays[i] = 0;
		}
		var user_pays_other = Array(myUsers.UserCount());
		for(var i = 0; i < user_pays_other.length; i++)
		{
			user_pays_other[i] = 0;
		}
		// расчёт коэффициента корректировки цены (koef) и суммарной стоимости заказа (cost_total_with_vat)
		for(var i = 0, quant_tmp, cost_tmp; i < myLines.length; i++)
		{
			if (myLines.GetChecked(i))
			{
				quant_tmp = myLines.GetQuantitiy(i);
				cost_tmp = myLines.GetPrice(i) * quant_tmp;
				user_pays[myLines.GetUserIndex(i)] += cost_tmp;
				cost_total_with_vat += cost_tmp;
			}
		}
		if (cost_total_with_vat < 50)
		{
			fees_tmp += 3;//Orders, which are below 50€, will be charged with 3€ additionally
		}
		var koef = (1 / 1.19 + fees_tmp / cost_total_with_vat);
		// расчёт скорректированных стоимостей лотов
		for(var i = 0, quant_tmp, price_tmp, cost_tmp, other_cost_tmp; i < myLines.length; i++)
		{
			if (myLines.GetChecked(i))
			{
				quant_tmp = myLines.GetQuantitiy(i);
				price_tmp = myLines.GetPrice(i) * koef;
				cost_tmp = price_tmp * quant_tmp;
				myLines.pay_prices[i].text = OutputCost(price_tmp);
				myLines.pay_costs[i].text = OutputCost(cost_tmp);
				if (myLines.GetOtherPrice(i) > 0)
				{
					other_cost_tmp = myLines.GetOtherPrice(i) * quant_tmp;
					user_pays_other[myLines.GetUserIndex(i)] += (cost_tmp - other_cost_tmp);
				}
			}
		}
		// расчёт стоимости заказа для каждого участника (to_pay)
		for(var i = 0, to_pay; i < myUsers.UserCount(); i++)
		{
			to_pay = user_pays[i] * koef;
			user_pays_total_without_vat += to_pay;
			this.user_structs_cost_eur[i].text = OutputCost(to_pay);
			this.user_structs_cost_rur[i].text = OutputCost(to_pay * myCurrency.value);
			if (user_pays_other[i] != 0)
			{
				this.user_structs_cost_eur[i].text += " [" + OutputCost(user_pays_other[i]) + "]";
				this.user_structs_cost_rur[i].text += " [" + OutputCost(user_pays_other[i] * myCurrency.value) + "]";
			}
		}
		this.total_eur_text.text = OutputCost(user_pays_total_without_vat) + " (" + OutputCost(cost_total_with_vat + fees_tmp) + ")";
		this.total_rur_text.text = OutputCost(user_pays_total_without_vat * myCurrency.value) + " (" + OutputCost((cost_total_with_vat + fees_tmp) * myCurrency.value) + ")";
	}
}

function SetCookie(val_name, value)
{
	document.cookie = val_name + "=" + (encodeURIComponent(value));
}

function GetCookie(val_name)
{
	var allcookies = document.cookie;
	var pos_st = allcookies.indexOf(val_name + "=");
	if (pos_st == -1) return "";
	var pos_end = allcookies.indexOf(";", pos_st);
	if (pos_end == -1) pos_end = allcookies.length;
	return allcookies.substring(pos_st + val_name.length + 1, pos_end);
}

function ClearNode(x)
{
	while (x.hasChildNodes()) x.removeChild(x.firstChild);
}

function ClearArray(x)
{
	while (x.pop()) ;
}

function CostToFloat(x)
{
	return parseFloat(x.replace(/,/, "."));
}

function OutputCost(x)
{
	var str = String(Math.round(x * 100) / 100);
	var p = str.search(/\./);
	var r = (str.length - p);

	if (p > 0) {
		if (r == 2)
		{
			str += "0";
		}
	}
	else
	{
		str += ".00";
	}

	return str.replace(/\./, ",");
}

function onChangeUBar()
{
	myLines.SaveChoice();
	myTotal.Recalc();
}

function AddUser()
{
	if (myUsers.Add())
	{
		myLines.RefreshUBars();
		myTotal.Refresh();
	}
}

function DeleteUser(x)
{
	myUsers.Del(x);
	myLines.RefreshUBars();
	myTotal.Refresh();
}

function InsertObjects()
{
	var href = String(document.location);
	if (href.search(/shopping_cart/) == -1) return;

	var tables = document.getElementsByTagName("table");
	if (tables.length == 0) return;

	var goods_table = tables[0];
	var goods_table_body = goods_table.getElementsByTagName("tbody")[0]
	var goods_table_lines = goods_table_body.getElementsByTagName("tr");
	// Лоты (myLine)
	for(var i = 0, price, quantity_text, tmp; i < goods_table_lines.length - 2; i = i + 3)
	{
		quantity_text = goods_table_lines[i + 1].childNodes[0].firstChild;
		price = CostToFloat(goods_table_lines[i + 1].childNodes[1].text.split(" ")[1]);//стоимость по типу " 2,25 EUR"
		// линия (лот)
		goods_table_lines[i].firstChild.rowSpan = 3;
		goods_table_body.insertBefore(myLines.Create(price, quantity_text), goods_table_lines[i + 2]);
		// "актуальные" цены
		goods_table_lines[i + 1].childNodes[1].appendChild(document.createElement("br"));
		goods_table_lines[i + 1].childNodes[1].appendChild(myLines.CreatePPrice());
		goods_table_lines[i + 1].childNodes[2].appendChild(document.createElement("br"));
		goods_table_lines[i + 1].childNodes[2].appendChild(myLines.CreatePCost());
	}
	myLines.RefreshUBars();
	// Итого (myTotal)
	goods_table_body.insertBefore(myTotal.Create(), goods_table_lines[goods_table_lines.length - 2]);
	myTotal.Refresh();
}

myUsers.Load();
document.onload = InsertObjects;